namespace Tiger.Game.Habbos;

public class Habbo
{
    public virtual int Id { get; set; }
    public virtual string Username { get; set; } = null!;
    public virtual string Email { get; set; } = null!;
    public virtual DateTime AccountCreated { get; set; }
    public virtual DateTime? LastLogin { get; set; }
    public virtual string Motto { get; set; } = null!;
    public virtual string Figure { get; set; } = null!;
    public virtual string Gender { get; set; } = null!;
    public virtual int Rank { get; set; }
    public virtual int Credits { get; set; }
    public virtual bool Online { get; set; }
    public virtual int HomeRoom { get; set; }
    public virtual int AchievementScore { get; set; }
    public virtual int? GroupId { get; set; }
    public virtual string? SsoTicket { get; set; }
    public virtual IDictionary<int, Activitypoints> Activitypoints { get; set; } = new Dictionary<int, Activitypoints>();
    public virtual ICollection<Badge> Badges { get; set; } = new List<Badge>();

    public virtual IDictionary<int, HabboAchievement> Achievements { get; set; } = new Dictionary<int, HabboAchievement>();

    public virtual void UpdateCurrency(int type, int amount)
    {
        if (!Activitypoints.ContainsKey(type))
        {
            Activitypoints.Add(type, new Activitypoints
            {
                Habbo = this,
                Amount = amount,
                Type = type
            });
            return;
        }

        Activitypoints[type].Amount += amount;
    }
}